import scala.collection.mutable.ListBuffer

object Main extends App{

  class Library() {
    var library: ListBuffer[Medium] = new ListBuffer[Medium]

    def store(medium: Medium): Unit = {
      var n: Int = exists(medium.title)
      if (n == -1) {
        library.append(medium)
        println(medium.title + " successfully added !")
      } else {
        println("Something went wrong with " + medium.title)
      }
    }

    def remove(name: String): Boolean = {
      var n: Int = exists(name)
      if (n != -1) {
        library.remove(n)
        println(name + " successfully removed !")
        return true
      }
      println("Something went wrong with " + name)
      return false
    }

    def exists(name: String): Int = {
      for (i <- 0 to library.length-1) {
        if (library(i).title == name) {
          return i
        }
      }
      return -1
    }

    override def toString(): String = {
      var string: String = new String()
      string = " -- LIBRARY --\n" + "--------------------------------------------------------\n"
      for (i <- 0 to library.length-1) {
        string += library(i).toString + "\n"
      }
      string += "--------------------------------------------------------\n"
      return string
    }
  }

  class Medium(_title: String, _date: String, _category: String, _rating: Int) {
    var title = _title
    var date = _date
    var category = _category
    var rating = _rating

    override def toString(): String = {
      get_info()
    }

    def rate(_rating: Int) {
      rating = _rating
    }

    def get_date(): String = {
      return date
    }

    def get_info(): String = {

      return "Title: " + title + ", Date: " + date + ", Category: " + category + " , Rating: " + rating
    }

  }

  class Book(_title: String, _date: String, _author: String, _category: String, _rating:Int) extends Medium(_title, _date, _category, _rating) {
    var author = _author

    override def get_info(): String = {
      return super.get_info + ", Author: " + author
    }
  }

class Newspaper(_title: String, _editor: String,  _date: String, _category: String, _rating:Int) extends Medium(_title, _date, _category, _rating) {
    var editor = _editor

    override def get_info(): String = {

      return super.get_info + ", Editor: " + editor
    }
}

class Vinyl(_title: String, _artist: String, _date: String, _category: String, _rating:Int) extends Medium(_title, _date, _category, _rating) {
  var artist = _artist

  override def get_info(): String = {
    return super.get_info + ", Artist: " + artist
  }
}

var library: Library = new Library
var B1 = new Book("Python for dummies", "2001", "Mr. Robot", "Software development", 2)
var B2 = new Book("How to become a billionaire ?", "1985", "Scrooge McDuck", "Economy", 4)
var B3 = new Book("What does bastard mean ?", "2016", "Jon Snow", "English", 5)

var N1 = new Newspaper("Test", "2018", "test", "test", 4)

library.store(B1)
library.store(B2)
library.store(B3)

print(library.toString)

library.remove("How to become a billionaire ?")

print(library.toString)
}
